/*
*
* Copyright (c) 2019 Texas Instruments Incorporated
*
* All rights reserved not granted herein.
*
* Limited License.
*
* Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive
* license under copyrights and patents it now or hereafter owns or controls to make,
* have made, use, import, offer to sell and sell ("Utilize") this software subject to the
* terms herein.  With respect to the foregoing patent license, such license is granted
* solely to the extent that any such patent is necessary to Utilize the software alone.
* The patent license shall not apply to any combinations which include this software,
* other than combinations with devices manufactured by or for TI ("TI Devices").
* No hardware patent is licensed hereunder.
*
* Redistributions must preserve existing copyright notices and reproduce this license
* (including the above copyright notice and the disclaimer and (if applicable) source
* code license limitations below) in the documentation and/or other materials provided
* with the distribution
*
* Redistribution and use in binary form, without modification, are permitted provided
* that the following conditions are met:
*
* *       No reverse engineering, decompilation, or disassembly of this software is
* permitted with respect to any software provided in binary form.
*
* *       any redistribution and use are licensed by TI for use only with TI Devices.
*
* *       Nothing shall obligate TI to provide you with source code for the software
* licensed and provided to you in object code.
*
* If software source code is provided to you, modification and redistribution of the
* source code are permitted provided that the following conditions are met:
*
* *       any redistribution and use of the source code, including any resulting derivative
* works, are licensed by TI for use only with TI Devices.
*
* *       any redistribution and use of any object code compiled from the source code
* and any resulting derivative works, are licensed by TI for use only with TI Devices.
*
* Neither the name of Texas Instruments Incorporated nor the names of its suppliers
*
* may be used to endorse or promote products derived from this software without
* specific prior written permission.
*
* DISCLAIMER.
*
* THIS SOFTWARE IS PROVIDED BY TI AND TI'S LICENSORS "AS IS" AND ANY EXPRESS
* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL TI AND TI'S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,
* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/
/*
  Note: Elektrobit Automotive GmbH modified the original code provided
        by the third party supplier. The modification is provided for
        convenience.
        Please use the modification on your discretion and account, or
        use the unmodified files provided with this distribution. 
  Please see for the reasons in the file ImportantNotes.txt for tag

ASCTI-305  update MemMap handling 
*/

[!IF "(as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPreCompile') or (as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPostBuild')"!]
 /***************************************************************************
  Project: [!"$project"!]
  Date   : [!"$datetime"!]

  This file is generated by EB Tresos
  Do not modify this file, otherwise the software may behave in unexpected way.

 *****************************************************************************/


/*******************************************************************************
 *  INCLUDES
 ******************************************************************************/
#include "Can.h"
#include "Can_Cfg.h"

/*
 * Design: MCAL-6077,MCAL-6079,MCAL-5907
 */

/*  Version checking  */
 #if ((CAN_SW_MAJOR_VERSION != (2U))||(CAN_SW_MINOR_VERSION != (0U)))
    #error "Version numbers of Can_Cfg.c and Can.h are inconsistent!"
#endif

/*******************************************************************************
 *  GLOBAL DATA
 ******************************************************************************/
#define CAN_START_SEC_CONFIG_DATA
#include "Can_MemMap.h"

[!AUTOSPACING!]

[!IF "(as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPreCompile')"!]
/* Baud Rate Structure for all configsets */
[!VAR "CLK" = "1"!]
[!LOOP "as:modconf('Can')[1]/CanConfigSet/CanController/*"!][!LOOP "CanControllerBaudrateConfig/*"!]
static Can_BaudConfigType
    [!"../../../../@name"!]_[!"../../@name"!]_[!"@name"!] =
{
    [!"CanControllerBaudRate"!]U,      /* in Kbps */
    [!"CanControllerPropSeg"!]U,       /* Prop Segement value */
    [!"CanControllerSeg1"!]U,          /* Phase Segment 1 */
    [!"CanControllerSeg2"!]U,          /* Phase Segment 2 */
    [!"CanControllerSyncJumpWidth"!]U, /* Sync jump width */
    [!"num:i(CanControllerPropSeg+CanControllerSeg1+CanControllerSeg2+CanControllerSyncJumpWidth)"!]U, /* Sum of all timing parameters */
    [!VAR "CLK" = "num:i(as:modconf('Can')/CanGeneral/CANFDCLK)"!]
    [!VAR "brp" = "(num:i(round(($CLK*1000)div(CanControllerBaudRate*(1+CanControllerPropSeg+CanControllerSeg1+CanControllerSeg2)))))"!]
    [!ASSERT "num:i($brp) < 512","STOP: BRP more than 512 for a controller is not allowed"!]
    [!"num:i($brp)"!]U,   /* Controller BRP value for Baud */
	[!IF "node:exists(CanControllerFdBaudrateConfig/*) = 'true'"!]
 /* Data phase Baudrate */
    {
        [!"CanControllerFdBaudrateConfig/*/CanControllerFdBaudRate"!]U,     /* in Kbps */
        [!"CanControllerFdBaudrateConfig/*/CanControllerPropSeg"!]U,        /* Prop Segement value */
        [!"CanControllerFdBaudrateConfig/*/CanControllerSeg1"!]U,           /* Phase Segment 1 */
        [!"CanControllerFdBaudrateConfig/*/CanControllerSeg2"!]U,           /* Phase Segment 2 */
        [!"CanControllerFdBaudrateConfig/*/CanControllerSyncJumpWidth"!]U,  /* Sync jump width */
        [!"num:i(CanControllerFdBaudrateConfig/*/CanControllerPropSeg+CanControllerFdBaudrateConfig/*/CanControllerSeg1+CanControllerFdBaudrateConfig/*/CanControllerSeg2+CanControllerFdBaudrateConfig/*/CanControllerSyncJumpWidth)"!]U, /* Sum of all timing parameters */
        [!VAR "CANFDCLK" = "num:i(as:modconf('Can')/CanGeneral/CANFDCLK)"!]
        [!VAR "brp" = "(num:i(round(($CANFDCLK*1000)div(CanControllerFdBaudrateConfig/*/CanControllerFdBaudRate*(1+CanControllerFdBaudrateConfig/*/CanControllerPropSeg+CanControllerFdBaudrateConfig/*/CanControllerSeg1+CanControllerFdBaudrateConfig/*/CanControllerSeg2)))))"!]
        [!ASSERT "num:i($brp) < 32","STOP: BRP more than 32 for a controller is not allowed"!]
        [!"num:i($brp)"!]U,   /* Controller BRP value for Baud */
        [!"CanControllerFdBaudrateConfig/*/CanControllerTrcvDelayCompensationOffset/*"!]U, /* Specifies the Transceiver Delay Compensation Offset in ns */
        (boolean) [!IF "CanControllerFdBaudrateConfig/*/CanControllerTxBitRateSwitch   = 'true'"!]TRUE[!ELSE!]FALSE[!ENDIF!], /* Specifies if the bit rate switching shall be used */
        [!IF "node:empty(CanControllerFdBaudrateConfig/*/CanControllerTrcvDelayCompensationOffset/*) = 'true'"!][!ERROR "CanControllerTrcvDelayCompensationOffset is not configured"!][!ENDIF!]
    }
[!ENDIF!]};
[!ENDLOOP!][!ENDLOOP!]

/*List of the Baudrate structures */
[!LOOP "as:modconf('Can')[1]/CanConfigSet/CanController/*"!]
static Can_BaudConfigType
    *[!"../../@name"!]_[!"@name"!]_BaudRateConfigList[]=
{
    [!LOOP "CanControllerBaudrateConfig/*"!]    &[!"../../../../@name"!]_[!"../../@name"!]_[!"@name"!],
    [!ENDLOOP!]
};

[!ENDLOOP!]

/* Controller structure defined here for all config sets */
[!LOOP "as:modconf('Can')[1]/CanConfigSet"!]
[!LOOP "CanController/*"!]
static Can_ControllerType
    [!"../../@name"!]_[!"@name"!] =
{
    &[!"../../@name"!]_[!"@name"!]_[!"node:name(node:ref(node:current()/CanControllerDefaultBaudrate))"!],  /* pointer to default Baud structure */
    [!"../../@name"!]_[!"@name"!]_BaudRateConfigList,  /* List of available Baudrate structs */
};
[!ENDLOOP!][!ENDLOOP!]

[!ENDIF!][!// /* VariantPreCompile or VariantPostBuild */

[!IF "(as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPreCompile') or (as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPostBuild')"!]
/* Controller structure defined here for all config sets */
[!VAR "Mcu_CanController0AlreadyConfigured" = "0"!][!//
[!VAR "Mcu_CanController1AlreadyConfigured" = "0"!][!//
[!VAR "tabs" = "num:i(1)"!][!//
[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J721E') or (as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
[!VAR "CanController0AlreadyConfigured" = "0"!][!//
[!VAR "CanController1AlreadyConfigured" = "0"!][!//
[!VAR "CanController2AlreadyConfigured" = "0"!][!//
[!VAR "CanController3AlreadyConfigured" = "0"!][!//
[!VAR "CanController4AlreadyConfigured" = "0"!][!//
[!VAR "CanController5AlreadyConfigured" = "0"!][!//
[!VAR "CanController6AlreadyConfigured" = "0"!][!//
[!VAR "CanController7AlreadyConfigured" = "0"!][!//
[!VAR "CanController8AlreadyConfigured" = "0"!][!//
[!VAR "CanController9AlreadyConfigured" = "0"!][!//
[!VAR "CanController10AlreadyConfigured" = "0"!][!//
[!VAR "CanController11AlreadyConfigured" = "0"!][!//
[!VAR "CanController12AlreadyConfigured" = "0"!][!//
[!VAR "CanController13AlreadyConfigured" = "0"!][!//
[!ENDIF!]
[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
[!VAR "CanController14AlreadyConfigured" = "0"!][!//
[!VAR "CanController15AlreadyConfigured" = "0"!][!//
[!VAR "CanController16AlreadyConfigured" = "0"!][!//
[!VAR "CanController17AlreadyConfigured" = "0"!][!//
[!ENDIF!]

[!LOOP "as:modconf('Can')[1]/CanConfigSet"!]
[!VAR "CanControllerIdIndx" = "0"!]
[!LOOP "CanController/*"!]
const struct Can_ControllerStruct_PC
    [!"../../@name"!]_PC_[!"@name"!] =
{
    CanConf_CanController_[!"@name"!],      /* Id as provided by GUI */
    [!IF "(num:i($CanControllerIdIndx)) != CanControllerId"!][!ERROR "Can Controller Id should start with 0,should be unique, increment by 1 and continue without any gaps"!][!ENDIF!]
    [!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J721E')"!]
    [!IF "(num:i($CanControllerIdIndx)) >= '16'"!][!ERROR "Number of controllers supported is 16 only"!][!ENDIF!]
    [!ENDIF!]
    [!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
    [!IF "(num:i($CanControllerIdIndx)) >= '20'"!][!ERROR "Number of controllers supported is 20 only"!][!ENDIF!]
    [!ENDIF!]
    (boolean) [!IF "CanControllerActivation = 'true'"!]TRUE[!ELSE!]FALSE[!ENDIF!],   /* Contoller is used=1 or not_used=0*/
    [!"num:inttohex(CanControllerBaseAddress)"!]U, /* Can Controller Base Address */
    [!IF "CanControllerBaseAddress = '1078984704'"!]
    [!VAR "Mcu_CanController0AlreadyConfigured" = "$Mcu_CanController0AlreadyConfigured+1"!][!//
    [!IF "(num:i($Mcu_CanController0AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCU_MCAN0 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCU_MCAN0'"!]
    [!IF "CanControllerBaseAddress != '1078984704'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '1079246848'"!]
    [!VAR "Mcu_CanController1AlreadyConfigured" = "$Mcu_CanController1AlreadyConfigured+1"!][!//
    [!IF "(num:i($Mcu_CanController1AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCU_MCAN1 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCU_MCAN1'"!]
    [!IF "CanControllerBaseAddress != '1079246848'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J721E') or (as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
    [!IF "CanControllerBaseAddress = '40927232'"!]
    [!VAR "CanController0AlreadyConfigured" = "$CanController0AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController0AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN0 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN0'"!]
    [!IF "CanControllerBaseAddress != '40927232'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '40992768'"!]
    [!VAR "CanController1AlreadyConfigured" = "$CanController1AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController1AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN1 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN1'"!]
    [!IF "CanControllerBaseAddress != '40992768'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '41058304'"!]
    [!VAR "CanController2AlreadyConfigured" = "$CanController2AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController2AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN2 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN2'"!]
    [!IF "CanControllerBaseAddress != '41058304'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '41123840'"!]
    [!VAR "CanController3AlreadyConfigured" = "$CanController3AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController3AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN3 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN3'"!]
    [!IF "CanControllerBaseAddress != '41123840'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '41189376'"!]
    [!VAR "CanController4AlreadyConfigured" = "$CanController4AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController4AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN4 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN4'"!]
    [!IF "CanControllerBaseAddress != '41189376'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '41254912'"!]
    [!VAR "CanController5AlreadyConfigured" = "$CanController5AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController5AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN5 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN5'"!]
    [!IF "CanControllerBaseAddress != '41254912'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '41320448'"!]
    [!VAR "CanController6AlreadyConfigured" = "$CanController6AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController6AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN6 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN6'"!]
    [!IF "CanControllerBaseAddress != '41320448'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '41385984'"!]
    [!VAR "CanController7AlreadyConfigured" = "$CanController7AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController7AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN7 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN7'"!]
    [!IF "CanControllerBaseAddress != '41385984'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '41451520'"!]
    [!VAR "CanController8AlreadyConfigured" = "$CanController8AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController8AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN8 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN8'"!]
    [!IF "CanControllerBaseAddress != '41451520'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '41517056'"!]
    [!VAR "CanController9AlreadyConfigured" = "$CanController9AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController9AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN9 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN9'"!]
    [!IF "CanControllerBaseAddress != '41517056'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "(num:i(CanControllerBaseAddress)) = '41582592'"!]
    [!VAR "CanController10AlreadyConfigured" = "$CanController10AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController10AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN10 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN10'"!]
    [!IF "(num:i(CanControllerBaseAddress)) != '41582592'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '41648128'"!]
    [!VAR "CanController11AlreadyConfigured" = "$CanController11AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController11AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN11 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN11'"!]
    [!IF "CanControllerBaseAddress != '41648128'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '41713664'"!]
    [!VAR "CanController12AlreadyConfigured" = "$CanController12AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController12AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN12 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN12'"!]
    [!IF "CanControllerBaseAddress != '41713664'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '41779200'"!]
    [!VAR "CanController13AlreadyConfigured" = "$CanController13AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController13AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN13 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN13'"!]
    [!IF "CanControllerBaseAddress != '41779200'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]

    [!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
    [!IF "CanControllerBaseAddress = '40402944'"!]
    [!VAR "CanController14AlreadyConfigured" = "$CanController14AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController14AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN14 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN14'"!]
    [!IF "CanControllerBaseAddress != '40402944'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '40468480'"!]
    [!VAR "CanController15AlreadyConfigured" = "$CanController15AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController15AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN15 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN15'"!]
    [!IF "CanControllerBaseAddress != '40468480'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '40534016'"!]
    [!VAR "CanController16AlreadyConfigured" = "$CanController16AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController16AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN2 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN16'"!]
    [!IF "CanControllerBaseAddress != '40534016'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerBaseAddress = '40599552'"!]
    [!VAR "CanController17AlreadyConfigured" = "$CanController17AlreadyConfigured+1"!][!//
    [!IF "(num:i($CanController17AlreadyConfigured)) > '1'"!][!ERROR "Controller Instance MCAN3 is already configured"!][!ENDIF!]
    [!ENDIF!]
    [!IF "CanControllerInstance = 'MCAN17'"!]
    [!IF "CanControllerBaseAddress != '40599552'"!]
    [!ERROR "Invalid Can Controller BaseAddress configured for selected instance, please check TRM"!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]

    [!WS "4"!][!IF "CanRxProcessing   = 'INTERRUPT'"!]CAN_TX_RX_PROCESSING_INTERRUPT[!ELSEIF "CanRxProcessing = 'MIXED'"!]CAN_TX_RX_PROCESSING_MIXED[!ELSE!]CAN_TX_RX_PROCESSING_POLLING[!ENDIF!],  /* Can Rx Processing Type */
    [!WS "4"!][!IF "CanTxProcessing   = 'INTERRUPT'"!]CAN_TX_RX_PROCESSING_INTERRUPT[!ELSEIF "CanTxProcessing = 'MIXED'"!]CAN_TX_RX_PROCESSING_MIXED[!ELSE!]CAN_TX_RX_PROCESSING_POLLING[!ENDIF!],  /* Can Tx Processing Type */
    (boolean) [!IF "CanBusoffProcessing = 'INTERRUPT'"!]TRUE[!ELSE!]FALSE[!ENDIF!],/* BusOff  TRUE = Interrupt FALSE = Polling */
    [!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J721E') or (as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!][!//
	[!IF "CanControllerInstance ='MCU_MCAN0'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCU_MCAN0,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCU_MCAN1'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCU_MCAN1,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN0'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN0,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN1'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN1,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN2'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN2,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN3'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN3,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN4'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN4,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN5'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN5,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN6'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN6,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN7'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN7,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN8'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN8,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN9'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN9,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN10'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN10,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN11'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN11,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN12'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN12,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN13'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN13,  /* Controller Instance */
	[!ENDIF!]
    [!ENDIF!]

    [!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!][!//
	[!IF "CanControllerInstance ='MCAN14'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN14,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN15'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN15,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN16'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN16,  /* Controller Instance */
    [!ELSEIF "CanControllerInstance ='MCAN17'"!][!//
    [!WS "0"!]CAN_CONTROLLER_INSTANCE_MCAN17,  /* Controller Instance */
	[!ENDIF!]
    [!ENDIF!]

	[!IF "node:exists((node:ref(node:current()/CanControllerDefaultBaudrate))/CanControllerFdBaudrateConfig/*) = 'true'"!](boolean)TRUE [!ELSE!](boolean)FALSE[!ENDIF!],  /* CAN FD Mode Enable */
};
[!VAR "CanControllerIdIndx" = "$CanControllerIdIndx+1"!]
[!ENDLOOP!][!ENDLOOP!]

[!ENDIF!][!// /* VariantPreCompile */

[!IF "(as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPreCompile')"!]
/*List of the Controller structures */
[!LOOP "as:modconf('Can')[1]/CanConfigSet"!]
static Can_ControllerType
    *[!"@name"!]_CanController_List[]=
{
    [!LOOP "CanController/*"!]    &[!"../../@name"!]_[!"@name"!],
    [!ENDLOOP!]
};
[!ENDLOOP!]
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPreCompile') or (as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPostBuild')"!]
[!LOOP "as:modconf('Can')[1]/CanConfigSet"!]
const struct Can_ControllerStruct_PC
    *[!"@name"!]_CanController_List_PC[CAN_NUM_CONTROLLER]=
{
    [!LOOP "CanController/*"!]    &[!"../../@name"!]_PC_[!"@name"!],
    [!ENDLOOP!]
};
[!ENDLOOP!]
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPreCompile')"!]
/* HW Filter structure for all configsets */
[!LOOP "as:modconf('Can')[1]/CanConfigSet/CanHardwareObject/*"!]
[!IF "CanObjectType = 'RECEIVE'"!]
[!IF "node:empty(CanHwFilter/*/CanHwFilterCode) = 'true'"!]
[!ERROR "Please configure HW filter struct as this mailbox object is HRH "!]
[!ENDIF!]
[!LOOP "CanHwFilter/*"!]
static Can_HwFilterType
    [!"../../../../@name"!]_[!"../../@name"!]_[!"@name"!] =
{
    [!"CanHwFilterCode"!]U,  /*CanHwFilterCode*/
    [!"CanHwFilterMask"!]U,  /*Filter Mask*/
};
[!ENDLOOP!]
[!ENDIF!]
[!ENDLOOP!]

/*List of the HW Filter structures */
[!LOOP "as:modconf('Can')[1]/CanConfigSet/CanHardwareObject/*"!]
[!IF "CanObjectType = 'RECEIVE'"!]
static Can_HwFilterType
    *[!"../../@name"!]_[!"@name"!]_HwFilterConfigList[]=
{
    [!LOOP "CanHwFilter/*"!]    &[!"../../../../@name"!]_[!"../../@name"!]_[!"@name"!],
    [!ENDLOOP!]
};
[!ENDIF!]
[!ENDLOOP!]

[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPreCompile')"!]
/* All the Mailbox objects(MB's) will be defined here for all config sets */
[!VAR "MCU_MCAN0TxCnt" = "0"!] [!VAR "MCU_MCAN0RxCnt" = "0"!] [!VAR "MCU_MCAN0TxFifoCnt" = "0"!]
[!VAR "MCU_MCAN1TxCnt" = "0"!] [!VAR "MCU_MCAN1RxCnt" = "0"!] [!VAR "MCU_MCAN1TxFifoCnt" = "0"!]
[!VAR "MCU_MCAN0StdFilterCnt" = "0"!] [!VAR "MCU_MCAN0ExtdFilterCnt" = "0"!]
[!VAR "MCU_MCAN1StdFilterCnt" = "0"!] [!VAR "MCU_MCAN1ExtdFilterCnt" = "0"!]
[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J721E') or (as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200') "!]
[!VAR "MCAN0TxCnt" = "0"!] [!VAR "MCAN0RxCnt" = "0"!] [!VAR "MCAN0TxFifoCnt" = "0"!]
[!VAR "MCAN1TxCnt" = "0"!] [!VAR "MCAN1RxCnt" = "0"!] [!VAR "MCAN1TxFifoCnt" = "0"!]
[!VAR "MCAN2TxCnt" = "0"!] [!VAR "MCAN2RxCnt" = "0"!] [!VAR "MCAN2TxFifoCnt" = "0"!]
[!VAR "MCAN3TxCnt" = "0"!] [!VAR "MCAN3RxCnt" = "0"!] [!VAR "MCAN3TxFifoCnt" = "0"!]
[!VAR "MCAN4TxCnt" = "0"!] [!VAR "MCAN4RxCnt" = "0"!] [!VAR "MCAN4TxFifoCnt" = "0"!]
[!VAR "MCAN5TxCnt" = "0"!] [!VAR "MCAN5RxCnt" = "0"!] [!VAR "MCAN5TxFifoCnt" = "0"!]
[!VAR "MCAN6TxCnt" = "0"!] [!VAR "MCAN6RxCnt" = "0"!] [!VAR "MCAN6TxFifoCnt" = "0"!]
[!VAR "MCAN7TxCnt" = "0"!] [!VAR "MCAN7RxCnt" = "0"!] [!VAR "MCAN7TxFifoCnt" = "0"!]
[!VAR "MCAN8TxCnt" = "0"!] [!VAR "MCAN8RxCnt" = "0"!] [!VAR "MCAN8TxFifoCnt" = "0"!]
[!VAR "MCAN9TxCnt" = "0"!] [!VAR "MCAN9RxCnt" = "0"!] [!VAR "MCAN9TxFifoCnt" = "0"!]
[!VAR "MCAN10TxCnt" = "0"!] [!VAR "MCAN10RxCnt" = "0"!] [!VAR "MCAN10TxFifoCnt" = "0"!]
[!VAR "MCAN11TxCnt" = "0"!] [!VAR "MCAN11RxCnt" = "0"!] [!VAR "MCAN11TxFifoCnt" = "0"!]
[!VAR "MCAN12TxCnt" = "0"!] [!VAR "MCAN12RxCnt" = "0"!] [!VAR "MCAN12TxFifoCnt" = "0"!]
[!VAR "MCAN13TxCnt" = "0"!] [!VAR "MCAN13RxCnt" = "0"!] [!VAR "MCAN13TxFifoCnt" = "0"!]
[!VAR "MCAN0StdFilterCnt" = "0"!] [!VAR "MCAN0ExtdFilterCnt" = "0"!]
[!VAR "MCAN1StdFilterCnt" = "0"!] [!VAR "MCAN1ExtdFilterCnt" = "0"!]
[!VAR "MCAN2StdFilterCnt" = "0"!] [!VAR "MCAN2ExtdFilterCnt" = "0"!]
[!VAR "MCAN3StdFilterCnt" = "0"!] [!VAR "MCAN3ExtdFilterCnt" = "0"!]
[!VAR "MCAN4StdFilterCnt" = "0"!] [!VAR "MCAN4ExtdFilterCnt" = "0"!]
[!VAR "MCAN5StdFilterCnt" = "0"!] [!VAR "MCAN5ExtdFilterCnt" = "0"!]
[!VAR "MCAN6StdFilterCnt" = "0"!] [!VAR "MCAN6ExtdFilterCnt" = "0"!]
[!VAR "MCAN7StdFilterCnt" = "0"!] [!VAR "MCAN7ExtdFilterCnt" = "0"!]
[!VAR "MCAN8StdFilterCnt" = "0"!] [!VAR "MCAN8ExtdFilterCnt" = "0"!]
[!VAR "MCAN9StdFilterCnt" = "0"!] [!VAR "MCAN9ExtdFilterCnt" = "0"!]
[!VAR "MCAN10StdFilterCnt" = "0"!] [!VAR "MCAN10ExtdFilterCnt" = "0"!]
[!VAR "MCAN11StdFilterCnt" = "0"!] [!VAR "MCAN11ExtdFilterCnt" = "0"!]
[!VAR "MCAN12StdFilterCnt" = "0"!] [!VAR "MCAN12ExtdFilterCnt" = "0"!]
[!VAR "MCAN13StdFilterCnt" = "0"!] [!VAR "MCAN13ExtdFilterCnt" = "0"!]
[!ENDIF!]

[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200') "!]
[!VAR "MCAN14TxCnt" = "0"!] [!VAR "MCAN14RxCnt" = "0"!] [!VAR "MCAN14TxFifoCnt" = "0"!]
[!VAR "MCAN15TxCnt" = "0"!] [!VAR "MCAN15RxCnt" = "0"!] [!VAR "MCAN15TxFifoCnt" = "0"!]
[!VAR "MCAN16TxCnt" = "0"!] [!VAR "MCAN16RxCnt" = "0"!] [!VAR "MCAN16TxFifoCnt" = "0"!]
[!VAR "MCAN17TxCnt" = "0"!] [!VAR "MCAN17RxCnt" = "0"!] [!VAR "MCAN17TxFifoCnt" = "0"!]
[!VAR "MCAN14StdFilterCnt" = "0"!] [!VAR "MCAN14ExtdFilterCnt" = "0"!]
[!VAR "MCAN15StdFilterCnt" = "0"!] [!VAR "MCAN15ExtdFilterCnt" = "0"!]
[!VAR "MCAN16StdFilterCnt" = "0"!] [!VAR "MCAN16ExtdFilterCnt" = "0"!]
[!VAR "MCAN17StdFilterCnt" = "0"!] [!VAR "MCAN17ExtdFilterCnt" = "0"!]
[!ENDIF!]

[!LOOP "as:modconf('Can')[1]/CanConfigSet"!]
[!LOOP "CanHardwareObject/*"!]
static Can_MailboxType
    [!"../../@name"!]_[!"@name"!] =
{
    [!WS "4"!][!IF "CanHandleType='FULL'"!]0U[!ELSE!]1U[!ENDIF!],  /*  CanHandleType 0=Full, 1=Basic */
    [!WS "4"!][!IF "CanIdType = 'EXTENDED'"!]1U[!ELSEIF "CanIdType = 'STANDARD'"!]0U[!ELSE!]2U[!ENDIF!],  /* CanIdType 0=standard 1=Extended 2=Mixed*/[!CR!]
    [!IF "'MCU_MCAN0' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCU_MCAN0TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCU_MCAN0TxCnt" = "$MCU_MCAN0TxCnt+1"!]
    [!IF "(num:i($MCU_MCAN0TxCnt) + num:i($MCU_MCAN0TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCU_MCAN0RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCU_MCAN0RxCnt" = "$MCU_MCAN0RxCnt+1"!]
    [!IF "(num:i($MCU_MCAN0RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCU_MCAN0TxFifoCnt" = "node:value(CanHwObjectCount)+$MCU_MCAN0TxFifoCnt"!]
    [!IF "(num:i($MCU_MCAN0TxCnt) + num:i($MCU_MCAN0TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCU_MCAN1' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCU_MCAN1TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCU_MCAN1TxCnt" = "$MCU_MCAN1TxCnt+1"!]
    [!IF "(num:i($MCU_MCAN1TxCnt) + num:i($MCU_MCAN1TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCU_MCAN1RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCU_MCAN1RxCnt" = "$MCU_MCAN1RxCnt+1"!]
    [!IF "(num:i($MCU_MCAN1RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCU_MCAN1TxFifoCnt" = "node:value(CanHwObjectCount) + $MCU_MCAN1TxFifoCnt"!]
    [!IF "(num:i($MCU_MCAN1TxCnt) + num:i($MCU_MCAN1TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J721E') or (as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
    [!IF "'MCAN0' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN0TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN0TxCnt" = "$MCAN0TxCnt+1"!]
    [!IF "(num:i($MCAN0TxCnt) + num:i($MCAN0TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN0RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN0RxCnt" = "$MCAN0RxCnt+1"!]
    [!IF "(num:i($MCAN0RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN0TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN0TxFifoCnt"!]
    [!IF "(num:i($MCAN0TxCnt) + num:i($MCAN0TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN1' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN1TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN1TxCnt" = "$MCAN1TxCnt+1"!]
    [!IF "(num:i($MCAN1TxCnt) + num:i($MCAN1TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN1RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN1RxCnt" = "$MCAN1RxCnt+1"!]
    [!IF "(num:i($MCAN1RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN1TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN1TxFifoCnt"!]
    [!IF "(num:i($MCAN1TxCnt) + num:i($MCAN1TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN2' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN2TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN2TxCnt" = "$MCAN2TxCnt+1"!]
    [!IF "(num:i($MCAN2TxCnt) + num:i($MCAN2TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN2RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN2RxCnt" = "$MCAN2RxCnt+1"!]
    [!IF "(num:i($MCAN2RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN2TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN2TxFifoCnt"!]
    [!IF "(num:i($MCAN2TxCnt) + num:i($MCAN2TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN3' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN3TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN3TxCnt" = "$MCAN3TxCnt+1"!]
    [!IF "(num:i($MCAN3TxCnt) + num:i($MCAN3TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN3RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN3RxCnt" = "$MCAN3RxCnt+1"!]
    [!IF "(num:i($MCAN3RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN3TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN3TxFifoCnt"!]
    [!IF "(num:i($MCAN3TxCnt) + num:i($MCAN3TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN4' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN4TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN4TxCnt" = "$MCAN4TxCnt+1"!]
    [!IF "(num:i($MCAN4TxCnt) + num:i($MCAN4TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN4RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN4RxCnt" = "$MCAN4RxCnt+1"!]
    [!IF "(num:i($MCAN4RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN4TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN4TxFifoCnt"!]
    [!IF "(num:i($MCAN4TxCnt) + num:i($MCAN4TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN5' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN5TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN5TxCnt" = "$MCAN5TxCnt+1"!]
    [!IF "(num:i($MCAN5TxCnt) + num:i($MCAN5TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN5RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN5RxCnt" = "$MCAN5RxCnt+1"!]
    [!IF "(num:i($MCAN5RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN5TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN5TxFifoCnt"!]
    [!IF "(num:i($MCAN5TxCnt) + num:i($MCAN5TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN6' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN6TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN6TxCnt" = "$MCAN6TxCnt+1"!]
    [!IF "(num:i($MCAN6TxCnt) + num:i($MCAN6TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN6RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN6RxCnt" = "$MCAN6RxCnt+1"!]
    [!IF "(num:i($MCAN6RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN6TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN6TxFifoCnt"!]
    [!IF "(num:i($MCAN6TxCnt) + num:i($MCAN6TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN7' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN7TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN7TxCnt" = "$MCAN7TxCnt+1"!]
    [!IF "(num:i($MCAN7TxCnt) + num:i($MCAN7TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN7RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN7RxCnt" = "$MCAN7RxCnt+1"!]
    [!IF "(num:i($MCAN7RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN7TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN7TxFifoCnt"!]
    [!IF "(num:i($MCAN7TxCnt) + num:i($MCAN7TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN8' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN8TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN8TxCnt" = "$MCAN8TxCnt+1"!]
    [!IF "(num:i($MCAN8TxCnt) + num:i($MCAN8TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN8RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN8RxCnt" = "$MCAN8RxCnt+1"!]
    [!IF "(num:i($MCAN8RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN8TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN8TxFifoCnt"!]
    [!IF "(num:i($MCAN8TxCnt) + num:i($MCAN8TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN9' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN9TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN9TxCnt" = "$MCAN9TxCnt+1"!]
    [!IF "(num:i($MCAN9TxCnt) + num:i($MCAN9TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN9RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN9RxCnt" = "$MCAN9RxCnt+1"!]
    [!IF "(num:i($MCAN9RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN9TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN9TxFifoCnt"!]
    [!IF "(num:i($MCAN9TxCnt) + num:i($MCAN9TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN10' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN10TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN10TxCnt" = "$MCAN10TxCnt+1"!]
    [!IF "(num:i($MCAN10TxCnt) + num:i($MCAN10TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN10RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN10RxCnt" = "$MCAN10RxCnt+1"!]
    [!IF "(num:i($MCAN10RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN10TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN10TxFifoCnt"!]
    [!IF "(num:i($MCAN10TxCnt) + num:i($MCAN10TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN11' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN11TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN11TxCnt" = "$MCAN11TxCnt+1"!]
    [!IF "(num:i($MCAN11TxCnt) + num:i($MCAN11TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN11RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN11RxCnt" = "$MCAN11RxCnt+1"!]
    [!IF "(num:i($MCAN11RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN11TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN11TxFifoCnt"!]
    [!IF "(num:i($MCAN11TxCnt) + num:i($MCAN11TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN12' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN12TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN12TxCnt" = "$MCAN12TxCnt+1"!]
    [!IF "(num:i($MCAN12TxCnt) + num:i($MCAN12TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN12RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN12RxCnt" = "$MCAN12RxCnt+1"!]
    [!IF "(num:i($MCAN12RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN12TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN12TxFifoCnt"!]
    [!IF "(num:i($MCAN12TxCnt) + num:i($MCAN12TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN13' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN13TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN13TxCnt" = "$MCAN13TxCnt+1"!]
    [!IF "(num:i($MCAN13TxCnt) + num:i($MCAN13TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN13RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN13RxCnt" = "$MCAN13RxCnt+1"!]
    [!IF "(num:i($MCAN13RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN13TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN13TxFifoCnt"!]
    [!IF "(num:i($MCAN13TxCnt) + num:i($MCAN13TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
[!ENDIF!]

[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
    [!IF "'MCAN14' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN14TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN14TxCnt" = "$MCAN14TxCnt+1"!]
    [!IF "(num:i($MCAN14TxCnt) + num:i($MCAN14TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN14RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN14RxCnt" = "$MCAN14RxCnt+1"!]
    [!IF "(num:i($MCAN14RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN14TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN14TxFifoCnt"!]
    [!IF "(num:i($MCAN14TxCnt) + num:i($MCAN14TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN15' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN15TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN15TxCnt" = "$MCAN15TxCnt+1"!]
    [!IF "(num:i($MCAN15TxCnt) + num:i($MCAN15TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN15RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN15RxCnt" = "$MCAN15RxCnt+1"!]
    [!IF "(num:i($MCAN15RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN15TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN15TxFifoCnt"!]
    [!IF "(num:i($MCAN15TxCnt) + num:i($MCAN15TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN16' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN16TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN16TxCnt" = "$MCAN16TxCnt+1"!]
    [!IF "(num:i($MCAN16TxCnt) + num:i($MCAN16TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN16RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN16RxCnt" = "$MCAN16RxCnt+1"!]
    [!IF "(num:i($MCAN16RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN16TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN16TxFifoCnt"!]
    [!IF "(num:i($MCAN16TxCnt) + num:i($MCAN16TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!IF "'MCAN17' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!][!//
    [!IF "node:value(CanHwObjectCount) = '1'"!]
    [!IF "CanObjectType = 'TRANSMIT'"!]
	[!"num:i($MCAN17TxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN17TxCnt" = "$MCAN17TxCnt+1"!]
    [!IF "(num:i($MCAN17TxCnt) + num:i($MCAN17TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ELSE!]
	[!"num:i($MCAN17RxCnt)"!]U,  /* HwHandle i.e Mailbox - Hw object in the controller */
    [!VAR "MCAN17RxCnt" = "$MCAN17RxCnt+1"!]
    [!IF "(num:i($MCAN17RxCnt)) > '64'"!][!ERROR "Number of Receive mailboxes supported is 64 only"!][!ENDIF!][!//
    [!ENDIF!]
    [!ELSE!]
	0U,  /* HwHandle i.e Mailbox - Hw object in the controller */
	[!IF "CanObjectType = 'TRANSMIT'"!]
    [!VAR "MCAN17TxFifoCnt" = "node:value(CanHwObjectCount) + $MCAN17TxFifoCnt"!]
    [!IF "(num:i($MCAN17TxCnt) + num:i($MCAN17TxFifoCnt)) > '32'"!][!ERROR "Number of Transmit mailboxes supported is 32 only"!][!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
    [!ENDIF!]
[!ENDIF!]

    [!WS "4"!][!IF "node:exists(CanHwObjectCount)"!][!"node:value(CanHwObjectCount)"!]U[!ELSE!]1U[!ENDIF!],   /* Length of the Mailbox */
    [!IF "node:value(CanHwObjectCount) = '0' "!][!ERROR "Hw Object count cannot be 0.Minimum value should be 1"!][!ENDIF!]
    [!WS "4"!][!IF "CanObjectType = 'TRANSMIT'"!]CAN_MAILBOX_DIRECTION_TX[!ELSE!]CAN_MAILBOX_DIRECTION_RX[!ENDIF!],  /* CanObjectType - Direction of Mailbox*/
    [!VAR "cntName" = "node:name(node:ref(node:current()/CanControllerRef))"!][!//
    &[!"../../@name"!]_PC_[!"$cntName"!],  /* Controller */[!//
	[!IF "CanObjectType = 'RECEIVE'"!][!CR!]
    [!WS "4"!][!"../../@name"!]_[!"@name"!]_HwFilterConfigList,  /* List of HW Filter structs */
    [!WS "4"!][!VAR "varHwFilterCnt" = "0"!][!LOOP "CanHwFilter/*"!][!VAR "varHwFilterCnt" = "$varHwFilterCnt+1"!][!ENDLOOP!][!"num:i($varHwFilterCnt)"!]U, /* Hw Filter Count */
    [!ELSE!][!CR!]
	[!WS "0"!]NULL_PTR,  /* List of HW Filter structs */
    [!WS "4"!]0U,   /* Hw Filter Count */
    [!ENDIF!]
    [!"CanFdPaddingValue/*"!]U,   /* Padding value for CAN FD message */
    [!IF "node:empty(CanFdPaddingValue/*) = 'true'"!][!ERROR "CanFdPaddingValue is not configured"!][!ENDIF!][!//
    [!IF "'MIXED' = node:value(node:ref(node:current()/CanControllerRef)/CanTxProcessing) or 'MIXED' = node:value(node:ref(node:current()/CanControllerRef)/CanRxProcessing)"!]
    (boolean)[!IF "CanHardwareObjectUsesPolling/* = 'true'"!]TRUE[!ELSE!]FALSE[!ENDIF!],  /* CanHardwareObjectUsesPolling */
    [!IF "node:empty(CanHardwareObjectUsesPolling/*) = 'true'"!][!ERROR "CanHardwareObjectUsesPolling is not configured"!][!ENDIF!][!//
    [!ELSE!]
	(boolean)FALSE,   /* CanHardwareObjectUsesPolling */
    [!ENDIF!]
};
	[!VAR "HwFilterCnt" = "0"!][!LOOP "CanHwFilter/*"!][!VAR "HwFilterCnt" = "$HwFilterCnt+1"!][!ENDLOOP!]
    [!IF "'MCU_MCAN0' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCU_MCAN0ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCU_MCAN0ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCU_MCAN0StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCU_MCAN0StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCU_MCAN0StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCU_MCAN0StdFilterCnt)"!]
    [!VAR "MCU_MCAN0ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCU_MCAN0ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCU_MCAN0StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCU_MCAN0ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ENDIF!]
    [!IF "'MCU_MCAN1' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCU_MCAN1ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCU_MCAN1ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCU_MCAN1StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCU_MCAN1StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCU_MCAN1StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCU_MCAN1StdFilterCnt)"!]
    [!VAR "MCU_MCAN1ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCU_MCAN1ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCU_MCAN1StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCU_MCAN1ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
	[!ENDIF!]
[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J721E') or (as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
    [!IF "'MCAN0' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN0ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN0ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN0StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN0StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN0StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN0StdFilterCnt)"!]
    [!VAR "MCAN0ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN0ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN0StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN0ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN1' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN1ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN1ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN1StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN1StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN1StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN1StdFilterCnt)"!]
    [!VAR "MCAN1ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN1ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN1StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN1ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN2' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN2ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN2ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN2StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN2StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN2StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN2StdFilterCnt)"!]
    [!VAR "MCAN2ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN2ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN2StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN2ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN3' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN3ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN3ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN3StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN3StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN3StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN3StdFilterCnt)"!]
    [!VAR "MCAN3ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN3ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN3StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN3ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN4' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN4ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN4ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN4StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN4StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN4StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN4StdFilterCnt)"!]
    [!VAR "MCAN4ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN4ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN4StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN4ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN5' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN5ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN5ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN5StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN5StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN5StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN5StdFilterCnt)"!]
    [!VAR "MCAN5ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN5ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN5StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN5ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN6' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN6ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN6ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN6StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN6StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN6StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN6StdFilterCnt)"!]
    [!VAR "MCAN6ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN6ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN6StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN6ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN7' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN7ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN7ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN7StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN7StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN7StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN7StdFilterCnt)"!]
    [!VAR "MCAN7ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN7ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN7StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN7ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN8' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN8ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN8ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN8StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN8StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN8StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN8StdFilterCnt)"!]
    [!VAR "MCAN8ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN8ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN8StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN8ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN9' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN9ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN9ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN9StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN9StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN9StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN9StdFilterCnt)"!]
    [!VAR "MCAN9ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN9ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN9StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN9ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN10' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN10ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN10ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN10StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN10StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN10StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN10StdFilterCnt)"!]
    [!VAR "MCAN10ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN10ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN10StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN10ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN11' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN11ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN11ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN11StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN11StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN11StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN11StdFilterCnt)"!]
    [!VAR "MCAN11ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN11ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN11StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN11ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN12' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN12ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN12ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN12StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN12StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN12StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN12StdFilterCnt)"!]
    [!VAR "MCAN12ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN12ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN12StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN12ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN13' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN13ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN13ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN13StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN13StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN13StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN13StdFilterCnt)"!]
    [!VAR "MCAN13ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN13ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN13StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN13ExtdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ENDIF!]
[!ENDIF!]

[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
    [!IF "'MCAN14' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN14ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN14ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN14StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN14StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN14StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN14StdFilterCnt)"!]
    [!VAR "MCAN14ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN14ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN14StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN14StdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN15' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN15ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN15ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN15StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN15StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN15StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN15StdFilterCnt)"!]
    [!VAR "MCAN15ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN15ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN15StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN15StdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN16' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN16ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN16ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN16StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN16StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN16StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN16StdFilterCnt)"!]
    [!VAR "MCAN16ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN16ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN16StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN16StdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ELSEIF "'MCAN17' = node:value(node:ref(node:current()/CanControllerRef)/CanControllerInstance)"!]
    [!IF "CanIdType = 'EXTENDED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN17ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN17ExtdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'STANDARD' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN17StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN17StdFilterCnt)"!]
    [!ELSEIF "CanIdType = 'MIXED' and CanObjectType = 'RECEIVE'"!]
    [!VAR "MCAN17StdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN17StdFilterCnt)"!]
    [!VAR "MCAN17ExtdFilterCnt" = "num:i($HwFilterCnt) + num:i($MCAN17ExtdFilterCnt)"!]
    [!ENDIF!]
    [!IF "(num:i($MCAN17StdFilterCnt)) > '128'"!][!ERROR "Number of Standard ID Filter elements supported is 128 only"!][!ENDIF!]
    [!IF "(num:i($MCAN17StdFilterCnt)) > '64'"!][!ERROR "Number of Extended ID Filter elements supported is 64 only"!][!ENDIF!]
    [!ENDIF!]
[!ENDIF!]
[!ENDLOOP!][!ENDLOOP!]
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPreCompile') or (as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPostBuild')"!]
/* All the Mailbox objects(MB's) will be defined here for all config sets */
[!LOOP "as:modconf('Can')[1]/CanConfigSet"!]
[!LOOP "CanHardwareObject/*"!]
static const struct Can_MailboxStruct_PC
    [!"../../@name"!]_PC_[!"@name"!] =
{
    CanConf_CanHardwareObject_[!"@name"!],  /* CanObjectId - Holds handle Id */
};
[!ENDLOOP!][!ENDLOOP!]
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPreCompile')"!]
/* List of the Mailboxes */
[!LOOP "as:modconf('Can')[1]/CanConfigSet"!]
static Can_MailboxType
    *[!"@name"!]_CanHardwareObject_List[] =
{
    [!LOOP "CanHardwareObject/*"!]
    [!WS "4"!]&[!"../../@name"!]_[!"@name"!],
    [!ENDLOOP!]
};
[!ENDLOOP!]
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPreCompile') or (as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPostBuild')"!]
/* List of the Mailboxes */
[!LOOP "as:modconf('Can')[1]/CanConfigSet"!]
const struct Can_MailboxStruct_PC
    *[!"@name"!]_CanHardwareObject_List_PC[CAN_NUM_MAILBOXES] =
{
    [!LOOP "CanHardwareObject/*"!]
    [!WS "4"!]&[!"../../@name"!]_PC_[!"@name"!],
    [!ENDLOOP!]
};
[!ENDLOOP!]
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/IMPLEMENTATION_CONFIG_VARIANT = 'VariantPreCompile')"!]
/*Can Config struct */
[!LOOP "as:modconf('Can')[1]/CanConfigSet"!]
const struct Can_ConfigType_s [!"@name"!] =
{
    [!"@name"!]_CanController_List, /* Controller List Pointer */
    [!WS "4"!][!VAR "maxController" = "0"!][!LOOP "./CanController/*"!][!VAR "maxController" = "$maxController+1"!][!ENDLOOP!]([!"num:i($maxController)"!]U),  /* max Controllers */
    [!"@name"!]_CanHardwareObject_List, /* Mailbox List Pointer */
    [!WS "4"!][!VAR "varmax" = "0"!][!LOOP "./CanHardwareObject/*"!][!VAR "varmax" = "$varmax+1"!][!ENDLOOP!]([!"num:i($varmax)"!]U),/* total number of mail boxes in this configset */
    .MaxBaudConfigID =
    {
        [!LOOP "./CanController/*"!][!//
        [[!"@index"!]] = [!"num:i(num:sub(num:i(count(CanControllerBaudrateConfig/*)),1))"!]U[!//
            [!IF "not(node:islast())"!],[!ENDIF!][!CR!][!//
        [!ENDLOOP!][!//
    }, /* Baud rate structure id */
    NULL_PTR,  /* Reserved Param used for future use */
};
[!ENDLOOP!]
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J721E')"!]
extern CONST(uint32, CAN_CONST)
Can_MsgmemRAMBaseAddr[CAN_MAX_CONTROLLER] =
{
  0x40500000U, /* MCU MCAN0 */
  0x40540000U, /* MCU MCAN1 */
  0x2708000U, /* Main MCAN0 */
  0x2718000U, /* Main MCAN1 */
  0x2728000U, /* Main MCAN2 */
  0x2738000U, /* Main MCAN3 */
  0x2748000U, /* Main MCAN4 */
  0x2758000U, /* Main MCAN5 */
  0x2768000U, /* Main MCAN6 */
  0x2778000U, /* Main MCAN7 */
  0x2788000U, /* Main MCAN8 */
  0x2798000U, /* Main MCAN9 */
  0x27a8000U, /* Main MCAN10 */
  0x27b8000U, /* Main MCAN11 */
  0x27c8000U, /* Main MCAN12 */
  0x27d8000U, /* Main MCAN13 */
};
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J721E')"!]
extern CONST(uint32, CAN_CONST)
    Can_MCANSSBaseAddr[CAN_MAX_CONTROLLER] =
{
    0x40520000U, /* MCU_MCAN0_SS */
    0x40560000U, /* MCU_MCAN1_SS*/
    0x2700000U, /* MCAN0_SS */
    0x2710000U, /* MCAN1_SS*/
    0x2720000U, /* MCAN2_SS */
    0x2730000U, /* MCAN3_SS */
    0x2740000U, /* MCAN4_SS */
    0x2750000U, /* MCAN5_SS */
    0x2760000U, /* MCAN6_SS */
    0x2770000U, /* MCAN7_SS */
    0x2780000U, /* MCAN8_SS*/
    0x2790000U, /* MCAN9_SS*/
    0x27a0000U, /* MCAN10_SS */
    0x27b0000U, /* MCAN11_SS */
    0x27c0000U, /* MCAN12_SS*/
    0x27d0000U, /* MCAN13_SS */
};
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J721E')"!]
extern CONST(uint32, CAN_CONST)
    Can_MCANCoreRegBaseAddr[CAN_MAX_CONTROLLER] =
{
    0x40528000U, /* MCU_MCAN0_CFG */
    0x40568000U, /* MCU_MCAN1_CFG*/
    0x2701000U, /* MCAN0_CFG */
    0x2711000U, /* MCAN1_CFG*/
    0x2721000U, /* MCAN2_CFG */
    0x2731000U, /* MCAN3_CFG */
    0x2741000U, /* MCAN4_CFG */
    0x2751000U, /* MCAN5_CFG */
    0x2761000U, /* MCAN6_CFG */
    0x2771000U, /* MCAN7_CFG */
    0x2781000U, /* MCAN8_CFG*/
    0x2791000U, /* MCAN9_CFG*/
    0x27a1000U, /* MCAN10_CFG */
    0x27b1000U, /* MCAN11_CFG */
    0x27c1000U, /* MCAN12_CFG*/
    0x27d1000U, /* MCAN13_CFG */
};
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J721E')"!]
extern CONST(uint32, CAN_CONST)
    Can_MCANECCAggrRegBaseAddr[CAN_MAX_CONTROLLER] =
{
    0x40700000U, /* MCU_MCAN0_ECC_AGGR */
    0x40701000U, /* MCU_MCAN1_ECC_AGGR*/
    0x2A78000U, /* MCAN0_ECC_AGGR */
    0x2A79000U, /* MCAN1_ECC_AGGR */
    0x2A7A000U, /* MCAN2_ECC_AGGR*/
    0x2A7B000U, /* MCAN3_ECC_AGGR */
    0x2A7C000U, /* MCAN4_ECC_AGGR */
    0x2A7D000U, /* MCAN5_ECC_AGGR */
    0x2A7E000U, /* MCAN6_ECC_AGGR */
    0x2A7F000U, /* MCAN7_ECC_AGGR */
    0x2A40000U, /* MCAN8_ECC_AGGR */
    0x2A41000U, /* MCAN9_ECC_AGGR*/
    0x2A42000U, /* MCAN10_ECC_AGGR*/
    0x2A43000U, /* MCAN11_ECC_AGGR */
    0x2A44000U, /* MCAN12_ECC_AGGR */
    0x2A45000U, /* MCAN13_ECC_AGGR*/
};
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
extern CONST(uint32, CAN_CONST)
Can_MsgmemRAMBaseAddr[CAN_MAX_CONTROLLER] =
{
  0x40500000U, /* MCU MCAN0 */
  0x40540000U, /* MCU MCAN1 */
  0x2708000U, /* Main MCAN0 */
  0x2718000U, /* Main MCAN1 */
  0x2728000U, /* Main MCAN2 */
  0x2738000U, /* Main MCAN3 */
  0x2748000U, /* Main MCAN4 */
  0x2758000U, /* Main MCAN5 */
  0x2768000U, /* Main MCAN6 */
  0x2778000U, /* Main MCAN7 */
  0x2788000U, /* Main MCAN8 */
  0x2798000U, /* Main MCAN9 */
  0x27a8000U, /* Main MCAN10 */
  0x27b8000U, /* Main MCAN11 */
  0x27c8000U, /* Main MCAN12 */
  0x27d8000U, /* Main MCAN13 */
  0x2688000U, /* Main MCAN14 */
  0x2698000U, /* Main MCAN15 */
  0x26a8000U, /* Main MCAN16 */
  0x26b8000U, /* Main MCAN17 */
};
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
extern CONST(uint32, CAN_CONST)
    Can_MCANSSBaseAddr[CAN_MAX_CONTROLLER] =
{
    0x40520000U, /* MCU_MCAN0_SS */
    0x40560000U, /* MCU_MCAN1_SS*/
    0x2700000U, /* MCAN0_SS */
    0x2710000U, /* MCAN1_SS*/
    0x2720000U, /* MCAN2_SS */
    0x2730000U, /* MCAN3_SS */
    0x2740000U, /* MCAN4_SS */
    0x2750000U, /* MCAN5_SS */
    0x2760000U, /* MCAN6_SS */
    0x2770000U, /* MCAN7_SS */
    0x2780000U, /* MCAN8_SS*/
    0x2790000U, /* MCAN9_SS*/
    0x27a0000U, /* MCAN10_SS */
    0x27b0000U, /* MCAN11_SS */
    0x27c0000U, /* MCAN12_SS*/
    0x27d0000U, /* MCAN13_SS */
    0x2680000U, /* MCAN14_SS */
    0x2690000U, /* MCAN15_SS */
    0x26a0000U, /* MCAN16_SS */
    0x26b0000U, /* MCAN17_SS */
};
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
extern CONST(uint32, CAN_CONST)
    Can_MCANCoreRegBaseAddr[CAN_MAX_CONTROLLER] =
{
    0x40528000U, /* MCU_MCAN0_CFG */
    0x40568000U, /* MCU_MCAN1_CFG*/
    0x2701000U, /* MCAN0_CFG */
    0x2711000U, /* MCAN1_CFG*/
    0x2721000U, /* MCAN2_CFG */
    0x2731000U, /* MCAN3_CFG */
    0x2741000U, /* MCAN4_CFG */
    0x2751000U, /* MCAN5_CFG */
    0x2761000U, /* MCAN6_CFG */
    0x2771000U, /* MCAN7_CFG */
    0x2781000U, /* MCAN8_CFG*/
    0x2791000U, /* MCAN9_CFG*/
    0x27a1000U, /* MCAN10_CFG */
    0x27b1000U, /* MCAN11_CFG */
    0x27c1000U, /* MCAN12_CFG*/
    0x27d1000U, /* MCAN13_CFG */
    0x2681000U, /* MCAN14_SS */
    0x2691000U, /* MCAN15_SS */
    0x26a1000U, /* MCAN16_SS */
    0x26b1000U, /* MCAN17_SS */
};
[!ENDIF!][!//

[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
extern CONST(uint32, CAN_CONST)
    Can_MCANECCAggrRegBaseAddr[CAN_MAX_CONTROLLER] =
{
    0x40700000U, /* MCU_MCAN0_ECC_AGGR */
    0x40701000U, /* MCU_MCAN1_ECC_AGGR*/
    0x2A78000U, /* MCAN0_ECC_AGGR */
    0x2A79000U, /* MCAN1_ECC_AGGR */
    0x2A7A000U, /* MCAN2_ECC_AGGR*/
    0x2A7B000U, /* MCAN3_ECC_AGGR */
    0x2A7C000U, /* MCAN4_ECC_AGGR */
    0x2A7D000U, /* MCAN5_ECC_AGGR */
    0x2A7E000U, /* MCAN6_ECC_AGGR */
    0x2A7F000U, /* MCAN7_ECC_AGGR */
    0x2A40000U, /* MCAN8_ECC_AGGR */
    0x2A41000U, /* MCAN9_ECC_AGGR*/
    0x2A42000U, /* MCAN10_ECC_AGGR*/
    0x2A43000U, /* MCAN11_ECC_AGGR */
    0x2A44000U, /* MCAN12_ECC_AGGR */
    0x2A45000U, /* MCAN13_ECC_AGGR*/
    0x2A46000U, /* MCAN14_ECC_AGGR */
    0x2A47000U, /* MCAN15_ECC_AGGR */
    0x2A48000U, /* MCAN16_ECC_AGGR */
    0x2A49000U, /* MCAN17_ECC_AGGR */
};
[!ENDIF!][!//

#define  CAN_STOP_SEC_CONFIG_DATA
#include "Can_MemMap.h"

/* ========================================================================== */
/*                          Function Definitions                              */
/* ========================================================================== */
#define CAN_START_SEC_ISR_CODE
#include "Can_MemMap.h"

[!LOOP "as:modconf('Can')[1]/CanConfigSet"!][!//
[!LOOP "CanController/*"!][!//
[!IF "CanControllerInstance = 'MCU_MCAN0'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCU_MCAN0 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_0_Int0ISR(void)
[!ELSE!][!//
CAN_ISR_TEXT_SECTION ISR(Can_0_Int0ISR)
[!ENDIF!][!//
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCU_MCAN0, 0x40500000U);
}
[!ENDIF!][!//
[!WS "0"!][!IF "CanControllerInstance = 'MCU_MCAN1'"!]
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCU_MCAN1 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_1_Int0ISR(void)
[!ELSE!][!//
CAN_ISR_TEXT_SECTION ISR(Can_1_Int0ISR)
[!ENDIF!][!//
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCU_MCAN1,0x40540000U);
}
[!WS "0"!][!ENDIF!][!//
[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J721E') or (as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]
[!IF "CanControllerInstance = 'MCAN0'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN0 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_2_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_2_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN0, 0x2708000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN1'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN1 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_3_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_3_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN1, 0x2718000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN2'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN2 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_4_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_4_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN2, 0x2728000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN3'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN3 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_5_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_5_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN3, 0x2738000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN4'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN4 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_6_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_6_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN4, 0x2748000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN5'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN5 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_7_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_7_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN5, 0x2758000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN6'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN6 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_8_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_8_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN6, 0x2768000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN7'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN7 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_9_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_9_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN7, 0x2778000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN8'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN8 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_10_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_10_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN8, 0x2788000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN9'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN9 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_11_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_11_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN9, 0x2798000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN10'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN10 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_12_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_12_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN10, 0x27a8000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN11'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN11 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_13_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_13_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN11, 0x27b8000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN12'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN12 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_14_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_14_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN12, 0x27c8000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN13'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN13 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_15_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_15_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN13, 0x27d8000U);
}
[!ENDIF!][!//
[!ENDIF!][!//
[!IF "(as:modconf('Can')[1]/CanGeneral/CanDeviceVariant = 'J7200')"!]

[!IF "CanControllerInstance = 'MCAN14'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN14 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_16_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_16_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN14, 0x2688000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN15'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN15 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_17_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_17_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN15, 0x2698000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN16'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN16 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_18_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_18_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN16, 0x26a8000U);
}
[!ENDIF!][!//
[!IF "CanControllerInstance = 'MCAN17'"!][!//
[!IF "as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_CAT1' or as:modconf('Can')[1]/CanGeneral/CanTypeofInterruptFunction = 'CAN_ISR_VOID' "!]
/** \brief MCAN17 Controller Instance ISR */
FUNC(void, CAN_CODE) Can_19_Int0ISR(void)
[!ELSE!]
CAN_ISR_TEXT_SECTION ISR(Can_19_Int0ISR)
[!ENDIF!]
{
Can_IntISR_Function(CAN_CONTROLLER_INSTANCE_MCAN17, 0x26b8000U);
}
[!ENDIF!][!//
[!ENDIF!][!//

[!ENDLOOP!][!ENDLOOP!][!//

#define CAN_STOP_SEC_ISR_CODE
#include "Can_MemMap.h"

[!ENDIF!][!//
/*******************************************************************************
 *  End of File: Can_Cfg.c
 ******************************************************************************/
